<?php
include("../includes/utility.php");

if (isset($_REQUEST['pagemode']) && ('Search' == $_REQUEST['pagemode']))
{
	process_form();
}
else
{
	display_form();
}

?>


<?php
function process_form()
{
	
	// Check for empty search criteria
	$searchstring = addslashes($_REQUEST["searchstring"]);
	if ($searchstring=="")
	{
		$errormsg = "Please enter something to search for.";
		display_form($errormsg);
		return;
	}

	// Connect to database
	OpenDB();

	// Check PFAST code first
	$query1 = "SELECT * FROM experiment WHERE left(Code, " . strlen($searchstring) . ")='$searchstring' ORDER BY SubmissionDate DESC";
	$result_pcode = mysql_query($query1);

	// Check protein name in Title, Conditions, Comments, Citation
	$query2 = "SELECT * FROM experiment WHERE instr(ProteinName, '$searchstring')!=0 OR instr(Conditions, '$searchstring')!=0 OR instr(Comments, '$searchstring')!=0 OR instr(Citation, '$searchstring')!=0 ORDER BY SubmissionDate DESC";
	$result_pname = mysql_query($query2);

	// Check Authors
	$query3 = "SELECT * FROM experiment WHERE instr(Authors, '$searchstring')!=0 ORDER BY SubmissionDate DESC";
	$result_author = mysql_query($query3);
	
	// If no matching record found, display error message
	if (@(mysql_num_rows($result_pcode) + mysql_num_rows($result_pname) + mysql_num_rows($result_author)) == 0)
	{
		$errormsg = "No matching records found for '$searchstring' in the PFAST database.";
		display_form($errormsg);
		return;
	}

	?>

<html>
<head>
	<title>PFAST: Database</title>
	<link rel="stylesheet" type="text/css" href="../includes/pfast.css">
</head>

<body>

<div id="centercontainer">

<?php include("../includes/header.php"); ?>

<div id="navigation">
	<a href="../">Home</a> >> 
	<a href="database.php">PFAST Database</a> >>
	Search Results
</div>

<div id="content">

	<h1>Search Results</h1>

	<p>Click on the experiment ID to see full details.</p>

	<?php
	// show matches for PFAST code	
	if (@mysql_num_rows($result_pcode) > 0)
	{
		?>
		<h2>PFAST Code Matches</h2> 
		<table id="browsedbresults" cellspacing="0">
			<tr>
				<th scope="col" class="leftmost">Code</th>
				<th scope="col">Protein Name</th>
				<th scope="col">Source</th>
				<th scope="col">Authors</th>
				<th scope="col">Date</th>
				<th scope="col" colspan="2">Action</th>
			</tr>

			<?php
			// variables for alternating row styles
			$thclass="th_norm";	$tdclass="td_norm";

			// Fetch a rows until there are no rows in the resultset
			while ($row = mysql_fetch_array($result_pcode))
			{
				?>

				<tr>
					<th scope="row" class="<?php echo $thclass; ?>"><a href="details.php?searchstring=<?php echo $searchstring; ?>&Code=<?php echo stripslashes($row["Code"]); ?>"><?php echo stripslashes($row["Code"]); ?></a></th>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["ProteinName"]); ?></td>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["Source"]); ?></td>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["Authors"]); ?></td>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["SubmissionDate"]); ?></td>
					<?php
					if (isAdmin())
					{
					?>
					<td class="<?php echo $tdclass; ?>"><a href="editdatabase.php?searchstring=<?php echo $searchstring; ?>&Code=<?php echo $row["Code"]; ?>">EDIT</a></td>
					
					<td class="<?php echo $tdclass; ?>"><a href="experimentdelete.php?searchstring=<?php echo $searchstring; ?>&Code=<?php echo $row["Code"]; ?>">DELETE</a></td>
					<?php
					}
					?>

				</tr>

				<?php
				// some code for alternating row styles
				if ($thclass=="th_norm")
				{
					$thclass="th_alt";
					$tdclass="td_alt";
				}
				else
				{
					$thclass="th_norm";	
					$tdclass="td_norm";
				}
			}
			?>
		</table>
	<?php
	}
	?>

	<?php
	// show matches for title, conditions, comments, citation
	if (@mysql_num_rows($result_pname) > 0)
	{
		?>
		<h2>Title, Conditions, Comments, and Citation Matches</h2> 
		<table id="browsedbresults" cellspacing="0">
			<tr>
				<th scope="col" class="leftmost">Code</th>
				<th scope="col">Protein Name</th>
				<th scope="col">Source</th>
				<th scope="col">Authors</th>
				<th scope="col">Date</th>
				<th scope="col" colspan="2">Action</th>
			</tr>

			<?php
			// variables for alternating row styles
			$thclass="th_norm";	$tdclass="td_norm";

			// Fetch a rows until there are no rows in the resultset
			while ($row = mysql_fetch_array($result_pname))
			{
				?>

				<tr>
					<th scope="row" class="<?php echo $thclass; ?>"><a href="details.php?searchstring=<?php echo $searchstring; ?>&Code=<?php echo stripslashes($row["Code"]); ?>"><?php echo stripslashes($row["Code"]); ?></a></th>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["ProteinName"]); ?></td>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["Source"]); ?></td>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["Authors"]); ?></td>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["SubmissionDate"]); ?></td>
					<?php
					if (isAdmin())
					{
					?>
					<td class="<?php echo $tdclass; ?>"><a href="editdatabase.php?searchstring=<?php echo $searchstring; ?>&Code=<?php echo $row["Code"]; ?>">EDIT</a></td>
					
					<td class="<?php echo $tdclass; ?>"><a href="experimentdelete.php?searchstring=<?php echo $searchstring; ?>&Code=<?php echo $row["Code"]; ?>">DELETE</a></td>

					<?php
					}
					?>
				</tr>

				<?php
				// some code for alternating row styles
				if ($thclass=="th_norm")
				{
					$thclass="th_alt";
					$tdclass="td_alt";
				}
				else
				{
					$thclass="th_norm";	
					$tdclass="td_norm";
				}
			}
			?>
		</table>
	<?php
	}
	?>

	<?php
	// show matches for author
	if (@mysql_num_rows($result_author) > 0)
	{
		?>
		<h2>Author Matches</h2> 
		<table id="browsedbresults" cellspacing="0">
			<tr>
				<th scope="col" class="leftmost">Code</th>
				<th scope="col">Protein Name</th>
				<th scope="col">Source</th>
				<th scope="col">Authors</th>
				<th scope="col">Date</th>
				<th scope="col" colspan="2">Action</th>
			</tr>

			<?php
			// variables for alternating row styles
			$thclass="th_norm";	$tdclass="td_norm";

			// Fetch a rows until there are no rows in the resultset
			while ($row = mysql_fetch_array($result_author))
			{
				?>

				<tr>
					<th scope="row" class="<?php echo $thclass; ?>"><a href="details.php?searchstring=<?php echo $searchstring; ?>&Code=<?php echo stripslashes($row["Code"]); ?>"><?php echo stripslashes($row["Code"]); ?></a></th>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["ProteinName"]); ?></td>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["Source"]); ?></td>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["Authors"]); ?></td>
					<td class="<?php echo $tdclass; ?>"><?php echo stripslashes($row["SubmissionDate"]); ?></td>
					<?php
					if (isAdmin())
					{
					?>
					<td class="<?php echo $tdclass; ?>"><a href="editdatabase.php?searchstring=<?php echo $searchstring; ?>&Code=<?php echo $row["Code"]; ?>">EDIT</a></td>
					
					<td class="<?php echo $tdclass; ?>"><a href="experimentdelete.php?searchstring=<?php echo $searchstring; ?>&Code=<?php echo $row["Code"]; ?>">DELETE</a></td>
					<?php
					}
					?>
				</tr>

				<?php
				// some code for alternating row styles
				if ($thclass=="th_norm")
				{
					$thclass="th_alt";
					$tdclass="td_alt";
				}
				else
				{
					$thclass="th_norm";	
					$tdclass="td_norm";
				}
			}
			?>
		</table>
	<?php
	}
	?>

</div>

<?php include("../includes/footer.php"); ?>

</div>

</body>
</html>

<?php
} // end of process_form()
?>






<?php
// begin function display_form();
function display_form($errormsg = "")
{
?>

<html>
<head>
	<title>PFAST: Database</title>
	<link rel="stylesheet" type="text/css" href="../includes/pfast.css">
</head>

<body>

<div id="centercontainer">

<?php include("../includes/header.php"); ?>

<div id="navigation">
	<a href="../">Home</a> >> PFAST Database
</div>

<div id="content">

	<h1>PFAST Database</h1>

	<p>Testing The main purpose of the PFAST database is to store the experimental results of Dr. Yana's research. By browsing the database, others can access her experimental results. </p>

	<h2>Search</h2>

	<p>Please enter a PFAST code, protein name, or author.  Partial names are acceptable.</p>

	<?php ShowErrorMessage($errormsg); ?>
	
	<form name='database' method='post' action='<?php echo $_SERVER["PHP_SELF"]; ?>'>
		<input name='searchstring' type='text' value='<?php echo $_POST["searchstring"]; ?>'>
		<input type='submit' name='pagemode' value='Search'>
	</form>

</div>

<?php include("../includes/footer.php"); ?>

</div>

</body>
</html>

<?php
} // end function display_form()
?>
