<?php
include ("../includes/utility.php");
//include ("../../includes/phplot/phplot.php");
checkSignedIn("/pfast/index.php");

$tempdir = "tmp" . $_SESSION["userid"];
$temppath = "./" . $tempdir . "/";

if (filesize($temppath . "Summary.txt")==0)
{
	display_error("There was an error in the input information.  Please double-check your input data and try again.");
}
else
{
	// generate graph
	
	// display results
	display_page();
}




function display_page($errormsg="")
{

$tempdir = "tmp" . $_SESSION["userid"];
$temppath = "./" . $tempdir . "/";

?>

<html>
<head>
	<title>PFAST: Fluorescence & Correlation Analysis Tool</title>
	<link rel="stylesheet" type="text/css" href="../includes/pfast.css">
</head>

<body>

<div id="centercontainer">

<?php include("../includes/header.php"); ?>

<div id="navigation">
	<a href="../">Home</a> >> 
	<a href="index.php">Fluorescence & Correlation Analysis Tool</a> >> 
	Results
</div>

<div id="content">

	<h1>FCAT Results</h1>

	<h2>Output files</h2>
	<p>These are output files of the Fluorescence & Correlation Analysis Tool:</p>
	<dl>
		<dt><a href="<?php echo $temppath; ?>Summary.txt">Summary.txt</a></dt>
		<dd>This file is a short summary of the analysis results.</dd>

		<dt><a href="<?php echo $temppath; ?>Result.txt">Result.txt</a></dt>
		<dd>This file contains detailed information about the analysis.</dd>

		<dt><a href="<?php echo $temppath; ?>Graph.txt">Graph.txt</a></dt>
		<dd>This file contains the necessary data for graph generation.</dd>
	</dl>

	<h2>Graph</h2>

	<p align='center'>(to be implemented)<br><img src="/pfast/images/phreqPlot.jpg"></p>

	<h2>Next Action</h2>

	<dl>
		<?php
		if (isAdmin())
		{
		?>

		<dt><a href="save.php">Submit results to database</a></dt>

		<?php
		}
		?>

		<dt><a href="FCAT.php">Perform another analysis</a></dt>
		<dt><a href="../index.php">Return to PFAST home</a></dt>
	</dl>

</div>

<?php include("../includes/footer.php"); ?>

</div>

</body>
</html>

<?php
}




function display_error($errormsg="")
{
?>

<html>
<head>
	<title>PFAST: Fluorescence & Correlation Analysis Tool</title>
	<link rel="stylesheet" type="text/css" href="../includes/pfast.css">
</head>

<body>

<div id="centercontainer">

<?php include("../includes/header.php"); ?>

<div id="navigation">
	<a href="../">Home</a> >> 
	<a href="index.php">Fluorescence & Correlation Analysis Tool</a> >> 
	Results
</div>

<div id="content">

	<h1>FCAT Results</h1>

	<?php ShowErrorMessage($errormsg); ?>

	<dl>
		<dt><a href="FCAT.php">Perform another analysis</a></dt>
		<dt><a href="../index.php">Return to PFAST home</a></dt>
	</dl>

</div>

<?php include("../includes/footer.php"); ?>

</div>

</body>
</html>

<?php
}
?>
