<?php
include ("../includes/utility.php");
checkAdmin("/pfast/index.php");


if (isset($_POST['pagemode']) && ('Save' == $_POST['pagemode']))
{
	process_form();
}
else
{
	display_form();
}



function process_form()
{
	$Code = addslashes(trim($_POST["Code"]));
	$ProteinName = addslashes(trim($_POST["ProteinName"]));
	$Source = addslashes(trim($_POST["Source"]));
	$Conditions = addslashes(trim($_POST["Conditions"]));
	$Settings = addslashes(trim($_POST["Settings"]));
	$Quencher = addslashes(trim($_POST["Quencher"]));
	$Comments = addslashes(trim($_POST["Comments"]));
	$Authors = addslashes(trim($_POST["Authors"]));
	$Citation = addslashes(trim($_POST["Citation"]));

	// Simple form validation (checks if any field is empty)
	if ($Code=="" || $ProteinName=="" || $Source=="" || $Conditions=="" || $Settings=="" || $Quencher=="" || $Comments=="" || $Authors=="" || $Citation=="")
	{
		$errormsg = "Please completely fill out the form (all fields are required).";
		display_form($errormsg);
		return;
	}

	// Connect to database
	OpenDB();

	// Check if code is already in use
	$query = "SELECT * FROM experiment WHERE Code='" . $Code . "'";
	$resultset = mysql_query($query);
	$num_rows = mysql_num_rows($resultset);

	// Code not in use, proceed
	if ($num_rows==0)
	{
		// Add record to database
		$query = "INSERT INTO user (firstname, lastname, email, phone, address, research, username, password) VALUES ('$firstname', '$lastname', '$email', '$phone', '$address', '$research', '$username', '$encrypted')";
		mysql_query($query);
	}
	// Code is in use, error
	else
	{
		$errormsg = "Please choose a different code. '" . $Code . "' is already used by another experiment.";
		display_form($errormsg);
		return;
	}

	// Read output files into strings
	$tempdir = "tmp" . $_SESSION["userid"];
	$temppath = "./" . $tempdir . "/";
	$file_sum = addslashes(trim(file_get_contents($temppath . "Summary.txt")));
	$file_res = addslashes(trim(file_get_contents($temppath . "Result.txt")));
	$file_grf = addslashes(trim(file_get_contents($temppath . "Graph.txt")));

	// Miscellaneous values
	$UserID = $_SESSION["userid"];
	$SubmissionDate = date("Y-m-d");

	// Insert experiment
	$query = "INSERT INTO experiment (Code, UserID, ProteinName, SubmissionDate, Source, Conditions, Settings, Quencher, Comments, Authors, Citation, FluorSummary, FluorResult, FluorGraph) VALUES ('$Code', $UserID, '$ProteinName', '$SubmissionDate', '$Source', '$Conditions', '$Settings', '$Quencher', '$Comments', '$Authors', '$Citation', '$file_sum', '$file_res', '$file_grf')";

	if (mysql_query($query))
	{
		display_success("The experiment was saved to the database.");
	}
	else
	{
		display_success("There was an error in saving the experiment to the database.");
	}

} // end process_form();





function display_form($errormsg="")
{
?>

<html>
<head>
	<title>PFAST: Fluorescence & Correlation Analysis Tool</title>
	<link rel="stylesheet" type="text/css" href="../includes/pfast.css">
</head>

<body>

<div id="centercontainer">

<?php include("../includes/header.php"); ?>

<div id="navigation">
	<a href="../">Home</a> >> 
	<a href="index.php">Fluorescence & Correlation Analysis Tool</a> >> 
	Save Results
</div>

<div id="content">

	<h1>Save Results</h1>

	<?php ShowErrorMessage($errormsg); ?>

	<form action="<?php echo $_SERVER["PHP_SELF"]; ?>" method="POST">

		<p><b>PFAST Code</b><br><input type='text' name='Code' size='10' maxlength='10' value='<?php echo $_REQUEST["Code"]; ?>'></p>

		<p><b>Title (Protein Name)</b><br><input type='text' name='ProteinName' size='80' value='<?php echo $_REQUEST["ProteinName"]; ?>'></p>
		
		<p><b>Source</b><br><input type='text' name='Source' size='80' value='<?php echo $_REQUEST["Source"]; ?>'></p>
		
		<p><b>Measurement Conditions</b><br><input type='text' name='Conditions' size='80' value='<?php echo $_REQUEST["Conditions"]; ?>'></p>

		<p><b>Spectrofluorometer Settings</b><br><input type='text' name='Settings' size='80' value='<?php echo $_REQUEST["Settings"]; ?>'></p>

		<p><b>Quencher</b><br><input type='text' name='Quencher' size='80' value='<?php echo $_REQUEST["Quencher"]; ?>'></p>

		<p><b>Comments</b><br><textarea rows='3' cols='80' name='Comments'><?php echo $_REQUEST["Comments"]; ?></textarea></p>
		
		<p><b>Authors</b><br><textarea rows='3' cols='80' name='Authors'><?php echo $_REQUEST["Authors"]; ?></textarea></p>

		<p><b>Citation</b><br><textarea rows='3' cols='80' name='Citation'><?php echo $_REQUEST["Citation"]; ?></textarea></p>

		<input type='submit' name='pagemode' value='Save' class='button'>
	</form>

</div>

<?php include("../includes/footer.php"); ?>

</div>

</body>
</html>

<?php
} // end function display_form()





function display_success($errormsg="")
{
?>

<html>
<head>
	<title>PFAST: Fluorescence & Correlation Analysis Tool</title>
	<link rel="stylesheet" type="text/css" href="../includes/pfast.css">
</head>

<body>

<div id="centercontainer">

<?php include("../includes/header.php"); ?>

<div id="navigation">
	<a href="../">Home</a> >> 
	<a href="index.php">Fluorescence & Correlation Analysis Tool</a> >> 
	Save Results
</div>

<div id="content">

	<h1>Save Results</h1>

	<?php ShowErrorMessage($errormsg); ?>

	<dl>
		<dt><a href='FCAT.php'>Perform another analysis</a></dt>
		<dt><a href='../'>Return to PFAST home</a></dt>
	</dl>
</div>

<?php include("../includes/footer.php"); ?>

</div>

</body>
</html>

<?php
} // end function display_success()
?>