<?php
include ("../includes/utility.php");
checkSignedIn("/pfast/index.php");

if (isset($_POST['pagemode']) && ('Upload' == $_POST['pagemode']))
{
	process_form();
}
else
{
	display_form();
}
?>


<?php
function process_form()
{
	// check to make sure a file was actually uploaded
	if (!(isset($_FILES['uploadfile']['tmp_name']) && ($_FILES['uploadfile']['size']>0)))
	{
		display_form("No file was received by the server.");
		return;
	}

	// Make temporary directory
	$tempdir = "tmp" . $_SESSION["userid"];
	@mkdir("./" . $tempdir);
	$temppath = "./" . $tempdir . "/";

	// Delete previous results, if they exist
	@exec("del " . $temppath . "*.txt", $result);
	@exec("del " . $temppath . "DATA", $result);

	// Copy input file to temp directory
	move_uploaded_file($_FILES['uploadfile']['tmp_name'], $temppath . 'DATA');

	if ($_SESSION["pkwhat"]=="PKK")
	{
		// Copy PKK to temp directory
		copy("pkk.exe", $temppath . "pkk.exe");

		// Copy PHP script to temp directory
		copy("runpkk.php", $temppath . "runpkk.php");

		// Run PKK
		header("Location: " . $temppath . "runpkk.php");
	}
	else if ($_SESSION["pkwhat"]=="PKM")
	{
		// Copy PKK to temp directory
		copy("pkm.exe", $temppath . "pkm.exe");

		// Copy PHP script to temp directory
		copy("runpkm.php", $temppath . "runpkm.php");

		// Run PKK
		header("Location: " . $temppath . "runpkm.php");
	}

} // end function process_form()
?>




<?php
function display_form($errormsg = "")
{
?>

<html>
<head>
	<title>PFAST: Fluorescence & Correlation Analysis Tool</title>
	<link rel="stylesheet" type="text/css" href="../includes/pfast.css">
</head>

<body>

<div id="centercontainer">

<?php include("../includes/header.php"); ?>

<div id="navigation">
	<a href="../">Home</a> >> 
	<a href="index.php">Fluorescence & Correlation Analysis Tool</a> >> 
	Upload Data File
</div>

<div id="content">

	<h1>Upload Data File</h1>

	<p>Select the data file from your computer for analysis:</p>

	<?php ShowErrorMessage($errormsg); ?>

	<form name='upload' action='<?php echo $_SERVER['PHP_SELF'];?>' method='post' enctype='multipart/form-data'>
		<input name='uploadfile' type='file'>
		<input name='pagemode' type='submit' value='Upload' class='button'>
	</form>

	<h2>File Specifications</h2>

	<?php
	if ($_SESSION["pkwhat"]=="PKK")
	{
	?>

	<p>Your input file must strictly follow these guidelines:</p>

	<dl>
		<dt>Line 1</dt>
		<dd>Name of protein, conditions, comments, etc.  This line is not processed by the algorithm.</dd>
	
		<dt>Line 2</dt>
		<dd>This line must contain 5 numbers, which are: 1) conventional number of quencher, 2) number of quencher concentrations, 3) shortest wavelength, 4) longest wavelength, and 5) the wavelength step.</dd>

		<dt>Line 3</dt>
		<dd>Enumerate the quencher concentrations (in M) in increasing order; the first concentration must be zero.</dd>

		<dt>Next Lines</dt>
		<dd>For each spectrum collected (i.e. number of quencher concentrations), list on a line the set of data points collected in increasing wavelength.</dd>

		<dt>Final Line</dt>
		<dd>Give a calibration tryptophan spectrum (i.e. spectrum of Trp in buffer measured at Lex=280nm)</dd>

		<dt>In all lines except for the first, values must be separated by spaces or commas.</dt>
	</dl>

	<p>For an example, take a look at this <a href="pkksampleinput.txt">sample input file</a>.</p>
	
	<?php
	}
	?>

	<?php
	if ($_SESSION["pkwhat"]=="PKM")
	{
	?>

	<p>Your input file must strictly follow these guidelines:</p>

	<dl>
		<dt>Line 1</dt>
		<dd>Name of protein, conditions, comments, etc.  This line is not processed by the algorithm.</dd>
	
		<dt>Line 2</dt>
		<dd>This line must contain 5 numbers, which are: 1) shortest wavelength, 2) longest wavelength, and 3) the wavelength step.</dd>

		<dt>Line 3</dt>
		<dd>List the set of data points collected in order of increasing wavelength.</dd>

		<dt>Final Line</dt>
		<dd>Give a calibration tryptophan spectrum (i.e. spectrum of Trp in buffer measured at Lex=280nm)</dd>

		<dt>In all lines except for the first, values must be separated by spaces or commas.</dt>
	</dl>

	<p>For an example, take a look at this <a href="pkmsampleinput.txt">sample input file</a>.</p>
	
	<?php
	}
	?>

</div>

<?php include("../includes/footer.php"); ?>

</div>

</body>
</html>

<?php
} // end of display_form()
?>