<?php
include ("../includes/utility.php");
checkSignedIn("/pfast/index.php");

if (isset($_REQUEST['pagemode']) && ('Finish >>' == $_REQUEST['pagemode']))
{
	check_step3();
}
else if (isset($_REQUEST['pagemode']) && ('Step 3 >>' == $_REQUEST['pagemode']))
{
	check_step2();
}
else if (isset($_REQUEST['pagemode']) && ('Step 2 >>' == $_REQUEST['pagemode']))
{
	check_step1();
}
else if (isset($_REQUEST['pagemode']) && ('<< Step 1' == $_REQUEST['pagemode']))
{
	save_step2();
	display_step1();
}
else if (isset($_REQUEST['pagemode']) && ('<< Step 2' == $_REQUEST['pagemode']))
{
	save_step3();
	display_step2();
}
else
{
	$_SESSION["line1"]="";
	$_SESSION["numquencher"]="";
	$_SESSION["numpoints"]="";
	$_SESSION["minwavelen"]="";
	$_SESSION["minwavelen2"]="";
	$_SESSION["wavestep"]="";
	display_step1();
}


function save_step2()
{
	for ($i = 1; $i <= $_SESSION["numquencher"]; $i++)
	{
		$fieldname = "qconc" . $i;
		$$fieldname = trim($_POST["qconc" . $i]);
		$_SESSION["qconc" . $i] = $$fieldname;
	}
}

function save_step3()
{
	$_SESSION["spectra"] = $_POST["spectra"];
}

?>

<?php
function check_step1()
{
	// grab values from form
	$line1 = addslashes(trim($_POST["line1"]));
	$numquencher= trim($_POST["numquencher"]);
	$minwavelen = trim($_POST["minwavelen"]);
	$maxwavelen = trim($_POST["maxwavelen"]);
	$wavestep = trim($_POST["wavestep"]);
	$quencher_convnum = trim($_POST["quencher_convnum"]);

	// save them to session variables in order to pass to next step (whatever the next step is)
	$_SESSION["line1"] = $line1;
	$_SESSION["numquencher"] = $numquencher;
	$_SESSION["minwavelen"] = $minwavelen;
	$_SESSION["maxwavelen"] = $maxwavelen;
	$_SESSION["wavestep"] = $wavestep;
	$_SESSION["quencher_convnum"] = $quencher_convnum;

	if ($_SESSION["pkwhat"]=="PKK")
	{
		// Simple form validation (checks if any field is empty)
		if ($line1=="" || $numquencher=="" || $minwavelen=="" || $maxwavelen=="" || $wavestep=="" || $quencher_convnum=="")
		{
			$errormsg = "Please completely fill out the form (all fields are required).";
			display_step1($errormsg);
			return;
		}
		// Check numbers
		if (!is_numeric($numquencher) || !is_numeric($quencher_convnum) || !is_numeric($minwavelen) || !is_numeric($maxwavelen) || !is_numeric($wavestep))
		{
			$errormsg = "Except for the comment line, all fields must contain numbers.";
			display_step1($errormsg);
			return;
		}
	}
	else if ($_SESSION["pkwhat"]=="PKM")
	{
		// Simple form validation (checks if any field is empty)
		if ($line1=="" || $minwavelen=="" || $maxwavelen=="" || $wavestep=="")
		{
			$errormsg = "Please completely fill out the form (all fields are required).";
			display_step1($errormsg);
			return;
		}
		// Check numbers
		if (!is_numeric($minwavelen) || !is_numeric($maxwavelen) || !is_numeric($wavestep))
		{
			$errormsg = "Except for the comment line, all fields must contain numbers.";
			display_step1($errormsg);
			return;
		}
	}

	display_step2();
}


function check_step2()
{
	if ($_SESSION["pkwhat"]=="PKK")
	{
		// grab values from form
		for ($i = 1; $i <= $_SESSION["numquencher"]; $i++)
		{
			$fieldname = "qconc" . $i;
			$$fieldname = trim($_POST[$fieldname]);
			$_SESSION["qconc" . $i] = $$fieldname;
		}

		// Simple form validation (checks if any field is empty)
		for ($i = 1; $i <= $_SESSION["numquencher"]; $i++)
		{
			$fieldname = "qconc" . $i;
			if ($$fieldname == "")
			{
				$errormsg = "Please completely fill out the form (all fields are required).";
				display_step2($errormsg);
				return;
			}
		}

		// Check numbers
		for ($i = 1; $i <= $_SESSION["numquencher"]; $i++)
		{
			$fieldname = "qconc" . $i;
			if (!is_numeric($$fieldname))
			{
				$errormsg = "Quencher concentrations must be numeric (e.g. 0.05, 0.20).";
				display_step2($errormsg);
				return;
			}
		}
	}

	display_step3();
}


function check_step3()
{
	$_SESSION["numpoints"] = (($_SESSION["maxwavelen"] - $_SESSION["minwavelen"]) / $_SESSION["wavestep"]) + 1;
	$_SESSION["spectra"] = trim($_POST["spectra"]);
	$_SESSION["trpspectrum"] = trim($_POST["trpspectrum"]) . " ";

	if ($_SESSION["pkwhat"]=="PKM") $_SESSION["numquencher"]=1;

	// Process numbers in textarea into individual elements in two-dimensional array
	$spectra = trim($_POST["spectra"]) . "\r\n";
	preg_match_all("/([^\n]+\r\n)/", $spectra, $rows);
	for ($r=0; $r<count($rows[1]); $r++)
	{
		// echo $rows[1][$r] . "<br>";
		preg_match_all("/([^ ,\r\n]+?)[ ,\r\n]/", $rows[1][$r], $cols);
		for ($c=0; $c<count($cols[1]); $c++)
		{
			// echo "[" . $cols[1][$c] . "]";
			$vals[$r][$c]=$cols[1][$c];
		}
		// echo "<br>";
	}

	// Process tryptophan spectrum into individual elements
	preg_match_all("/([^ ,\r\n]+?)[ ,\r\n]/", $_SESSION["trpspectrum"], $matches);
	for ($c=0; $c<count($matches[1]); $c++)
	{
		$trpvals[$c]=$matches[1][$c];
	}


	////////////////////
	// Form validation
	////////////////////

	if ($_SESSION["spectra"]=="" || $_SESSION["trpspectrum"]=="")
	{
		display_step3("Please complete the form -- all fields are required.");
		return;
	}
	
	// Check that we have the right number of rows
	if (count($vals)!=$_SESSION["numquencher"])
	{
		display_step3("Incorrect number of spectra (expected $_SESSION[numquencher], got " . count($vals) . ").");
		return;
	}
	
	// Check that the tryptophan spectrum has the right number of values
	if (count($trpvals)!=$_SESSION["numpoints"])
	{
		display_step3("Incorrect number of values in the tryptophan spectrum (expecting $_SESSION[numpoints], found " . count($trpvals) . ").");
		return;
	}

	// Check that each row has the right number of values
	for ($r=0; $r<count($vals); $r++)
	{
		if (count($vals[$r])!=$_SESSION["numpoints"])
		{
			display_step3("Incorrect number of intensity values on line " . ($r + 1) . " (expecting $_SESSION[numpoints], only found " . count($vals[$r]) . ").");
			return;
		}
	}

	// Check that all elements are numeric
	for ($r = 0; $r < count($vals); $r++)
	{
		for ($c = 0; $c < count($vals[0]); $c++)
		{
			if (!is_numeric($vals[$r][$c]) || !is_numeric($trpvals[$c]))
			{
				display_step3("Please enter only numbers seperated by spaces or commas.");
				return;
			}
		}
	}

	// Create input file "DATA" from form input

	// line 1
	$output = "";
	$output .= $_SESSION["line1"] . "\r\n";

	if ($_SESSION["pkwhat"]=="PKK")
	{
		// line 2
		$line2 = $_SESSION["quencher_convnum"] . ", ";
		$line2 .= $_SESSION["numquencher"] . ", ";
		$line2 .= $_SESSION["minwavelen"] . ", ";
		$line2 .= $_SESSION["maxwavelen"] . ", ";
		$line2 .= $_SESSION["wavestep"];
		$output .= $line2 . "\r\n";

		// line 3
		for ($qc = 1; $qc <= $_SESSION["numquencher"]; $qc++)
		{
			$line3 .= $_SESSION["qconc" . $qc];
			if ($qc != $_SESSION["numquencher"])
				$line3 .= ", ";
		}
		$output .= $line3 . "\r\n";

	}
	else if ($_SESSION["pkwhat"]=="PKM")
	{
		// line 2
		$line2 .= $_SESSION["minwavelen"] . ", ";
		$line2 .= $_SESSION["maxwavelen"] . ", ";
		$line2 .= $_SESSION["wavestep"];
		$output .= $line2 . "\r\n";
	}

	// spectra
	for ($r = 0; $r < count($vals); $r++)
	{
		$line = "";
		for ($c = 0; $c < count($vals[0]); $c++)
		{
			$line .= $vals[$r][$c];
			if ($c != count($vals[0]) - 1)
				$line .= ", ";
		}
		$line .= "\r\n";
		$output .= $line;
	}

	// tryptophan spectrum
	$line="";
	for ($c = 0; $c < count($trpvals); $c++)
	{
		$line .= $trpvals[$c];
		if ($c != count($trpvals) - 1)
			$line .= ", ";
	}
	$output .= $line . "\r\n";

	// Make temporary directory
	$tempdir = "tmp" . $_SESSION["userid"];
	@mkdir("./" . $tempdir);
	$temppath = "./" . $tempdir . "/";

	// Delete previous results, if they exist
	@exec("del " . $temppath . "*.txt", $result);
	@exec("del " . $temppath . "DATA", $result);

	// Make input file to temp directory
	file_put_contents($temppath . "DATA", $output);

	if ($_SESSION["pkwhat"]=="PKK")
	{
		// Copy PKK to temp directory
		copy("pkk.exe", $temppath . "pkk.exe");

		// Copy PHP script to temp directory
		copy("runpkk.php", $temppath . "runpkk.php");

		// Run PKK
		header("Location: " . $temppath . "runpkk.php");
	}
	else if ($_SESSION["pkwhat"]=="PKM")
	{
		// Copy PKK to temp directory
		copy("pkm.exe", $temppath . "pkm.exe");

		// Copy PHP script to temp directory
		copy("runpkm.php", $temppath . "runpkm.php");

		// Run PKK
		header("Location: " . $temppath . "runpkm.php");
	}

}

?>




<?php
function display_step1($errormsg = "")
{
?>

<html>
<head>
	<title>PFAST: Fluorescence & Correlation Analysis Tool</title>
	<link rel="stylesheet" type="text/css" href="../includes/pfast.css">
</head>

<body>

<div id="centercontainer">

<?php include("../includes/header.php"); ?>

<div id="navigation">
	<a href="../">Home</a> >> 
	<a href="FCAT.php">Fluorescence & Correlation Analysis Tool</a> >>
	Web Form Step 1
</div>

<div id="content">

	<h1>Step 1 of 3</h1>

	<p>Please provide the following information.  All fields are required.</p>

	<?php ShowErrorMessage($errormsg); ?>

	<form id='webform' action='<?php echo $_SERVER['PHP_SELF']; ?>' method='post'>
	
		<p>
		<b>Comment Line:</b><br>
		<input type='text' name='line1' value='<?php echo $_SESSION["line1"]; ?>' size='90'><br>
		Example (any text is ok):<br>
		<input type='text' value='20Feb1998, IGG.UR, Immunoglobulin G, bovine, 8M ures, KI, Lex=296.7, 315-400, St.5' size='90'>
		</p>

		<?php 
		if ($_SESSION["pkwhat"]=="PKK")
		{
		?>

		<p>
		<b>Number of spectra:</b><br>
		<input type='text' name='numquencher' value='<?php echo $_SESSION["numquencher"]; ?>' size='1' maxlength='1'> (e.g. 4)
		</p>

		<p>
		<b>Quencher Conventional Number:</b><br>
		<input type='text' name='quencher_convnum' value='<?php echo $_SESSION["quencher_convnum"]; ?>' size='1' maxlength='1'> (Acrylamide=1, CS<sup>+</sup>=2, I<sup>-</sup>=3, NO<sub>3</sub><sup>-</sup>=4)
		</p>

		<?php
		}
		?>

		<p>
		<b>Shortest wavelength:</b><br>
		<input type='text' name='minwavelen' value='<?php echo $_SESSION["minwavelen"]; ?>' size='3' maxlength='3'> (e.g. 315)
		</p>

		<p>
		<b>Longest wavelength:</b><br>
		<input type='text' name='maxwavelen' value='<?php echo $_SESSION["maxwavelen"]; ?>' size='3' maxlength='3'> (e.g. 400)
		</p>

		<p>
		<b>Wavelength step:</b><br>
		<input type='text' name='wavestep' value='<?php echo $_SESSION["wavestep"]; ?>' size='3' maxlength='3'> (e.g. 5);
		</p>

		<input type='submit' name='pagemode' value='Step 2 >>' class='button'>
	</form>

</div>

<?php include("../includes/footer.php"); ?>

</div>

</body>
</html>

<?php
} // end function display_step1();
?>




<?php
function display_step2($errormsg = "")
{
?>

<html>
<head>
	<title>PFAST: Fluorescence & Correlation Analysis Tool</title>
	<link rel="stylesheet" type="text/css" href="../includes/pfast.css">
</head>

<body>

<div id="centercontainer">

<?php include("../includes/header.php"); ?>

<div id="navigation">
	<a href="../">Home</a> >> 
	<a href="FCAT.php">Fluorescence & Correlation Analysis Tool</a> >>
	Web Form Step 2
</div>

<div id="content">

	<h1>Step 2 of 3</h1>

	<p>Please input the <b>quencher concentrations</b>, in order of increasing concentration, starting with zero.</p>

	<?php ShowErrorMessage($errormsg); ?>

	<form id='webform' action='<?php echo $_SERVER['PHP_SELF']; ?>' method='post'>

		<p>
		<?php
		if ($_SESSION["pkwhat"]=="PKK")
		{
			for ($i = 1; $i <= $_SESSION["numquencher"]; $i++)
			{
				echo "<input type='text' name='qconc$i' size='5' maxlength='5' value='" . $_SESSION["qconc" . $i] . "'> ";
			}
			echo "<br>(e.g. 0, 0.02, 0.05, 0.10)";
		}
		else if ($_SESSION["pkwhat"]=="PKM")
		{
			echo "This step is not applicable for single spectra.  Please continue to the next step.";
		}
		?>
		</p>

		<input type='submit' name='pagemode' value='<< Step 1' class='button'>
		<input type='submit' name='pagemode' value='Step 3 >>' class='button'>
	</form>

	<p></p>

</div>

<?php include("../includes/footer.php"); ?>

</div>

</body>
</html>

<?php
} // end function display_step2();
?>




<?php
function display_step3($errormsg = "")
{
?>

<html>
<head>
	<title>PFAST: Fluorescence & Correlation Analysis Tool</title>
	<link rel="stylesheet" type="text/css" href="../includes/pfast.css">
</head>

<body>

<div id="centercontainer">

<?php include("../includes/header.php"); ?>

<div id="navigation">
	<a href="../">Home</a> >> 
	<a href="FCAT.php">Fluorescence & Correlation Analysis Tool</a> >>
	Web Form Step 3
</div>

<div id="content">

	<h1>Step 3 of 3</h1>

	<?php ShowErrorMessage($errormsg); ?>

	<form id='webform' action='<?php echo $_SERVER['PHP_SELF']; ?>' method='post'>

		<p>
		Please input the <b>fluorescence intensity values</b> for each quencher concentration (in increasing concentration) at each wavelength (in order of increasing wavelength).<br>
		<textarea name='spectra' cols='90' rows='8' wrap='none'><?php echo $_SESSION["spectra"]; ?></textarea><br>
		Example:<br>
		75 96 138 180 216 241 255 258 251 235 216 193 169 144 121 101 85 71<br>
		72 79 113 149 176 198 209 211 205 192 175 157 137 116 99 81 68 58<br>
		70 74 105 137 162 178 187 188 183 171 155 138 119 101 84 70 61 50<br>
		58 62 89 113 134 148 153 153 147 137 125 110 95 81 68 57 48 40<br>
		</p>

		<p>
		<b>Tryptophan Spectrum</b> (i.e. spectrum of Trp in buffer measured at Lex=280nm)<br>
		<input type='text' name='trpspectrum' size='90' value='<?php echo $_SESSION["trpspectrum"]; ?>'><br>
		(e.g. 0.101, 0.192, 0.317, 0.466, 0.624, 0.769, 0.887, 0.965, 1.001, 0.996, 0.957, 0.893, 0.812, 0.722, 0.631, 0.542, 0.460, 0.386)
		</p>

		<input type='submit' name='pagemode' value='<< Step 2' class='button'>
		<input type='submit' name='pagemode' value='Finish >>' class='button'>
	</form>

</div>

<?php include("../includes/footer.php"); ?>

</div>

</body>
</html>

<?php
} // end function display_step3();
?>
